/**
 * @file hook.h
 * @brief Systemcall hooking functions.
 */

#ifndef __HOOK_H
#define __HOOK_H

#define HOOK(x)		original_##x = sys_call_table[__NR_##x];	\
			sys_call_table[__NR_##x] = borg_##x;
			
#define	UNHOOK(x)	sys_call_table[__NR_##x] = original_##x;

/** List of system calls known by linux. */
extern void **sys_call_table;

/**
 * Find the system call table.
 * @return zero on success and -1 on failure.
 */
extern int syscall_table_find(void);

/**
 * Hook on the system call table.
 * @return zero on success and -1 on failure.
 */
extern int syscall_table_hook(void);

/**
 * Unhook on the system call table.
 * @return zero on success and -1 on failure.
 */
extern int syscall_table_unhook(void);


#endif
